<script lang="ts">
    export let name: string
    export let type = 'text'
    export let value = ''
    export let placeholder: string = undefined
    export let optional = false
    export let hasErrors = false
    export let errors: string[] = []

    let incorrect: boolean
    $: incorrect = !!hasErrors || (errors && errors.length > 0)

    const flushErrors = () => {
        incorrect = false
        errors = []
    }

    const typeAction = (node: HTMLInputElement) => {
        node.type = type
    }
</script>

<label>
    <span>
        <slot />
        {#if optional}<small>Optional</small>{/if}
    </span>
    <input
        bind:value
        class:error={incorrect}
        {name}
        on:input={flushErrors}
        {placeholder}
        use:typeAction
    />
    {#if incorrect}
        <ul>
            {#each errors as error}
                <li>{error}</li>
            {/each}
        </ul>
    {:else}
        <slot name="tooltip" />
    {/if}
</label>

<style lang="postcss">
    label {
        @apply block mt-4;

        &:not(:first-of-type) {
            @apply mt-4;
        }
    }

    span {
        @apply flex justify-between items-baseline text-gray-700;
    }

    small {
        @apply text-sm text-gray-600;
    }

    input {
        @apply mt-1 w-full bg-gray-200 border-transparent rounded-lg p-3;
    }

    .error {
        @apply shadow-error;
    }

    ul {
        @apply mt-2 list-none;
    }

    li {
        @apply text-sm text-red-600 leading-none mb-1;
    }
</style>
